SystemOrganization addCategory: #'Pier-OmniBrowser-Core'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Nodes'!

ListItemWrapper subclass: #PRStructureItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ self species = anObject species
		and: [ self item = anObject item ]! !

!PRStructureItemWrapper methodsFor: 'converting' stamp: 'lr 3/9/2006 11:30'!
asString
	^ self item title! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
contents
	^ self item children collect: [ :each | self class with: each ]! !

!PRStructureItemWrapper methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
hasContents
	^ self item hasChildren! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ self item hash! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
item
	^ item! !

OBNode subclass: #PRPierNode
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

PRPierNode subclass: #PRDescriptionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRDescriptionNode methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
children
	self model hasChildren
		ifFalse: [ ^ super children ].
	^ self model children
		collect: [ :each | self class on: each ]! !

!PRDescriptionNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model label! !

PRPierNode subclass: #PRKernelNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
children
	^ Array with: (PRStructureNode on: self model root holder: self)! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context
	^ context! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context: aContext
	context := aContext! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model: aModel
	super model: aModel.
	self context: (PRContext kernel: aModel)! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model name! !

!PRPierNode class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aModel
	^ self new
		model: aModel;
		yourself! !

!PRPierNode methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ self species = anObject species
		and: [ self model = anObject model ]! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 5/28/2007 11:11'!
children
	^ #()! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
description
	^ Array with: (PRDescriptionNode on: self model description)! !

!PRPierNode methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ self model hash! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model
	^ model! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model: aModel
	model := aModel! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
text
	^ self model printString! !

PRPierNode subclass: #PRRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRRootNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
children
	^ self model collect: [ :each | PRKernelNode on: each ]! !

!PRRootNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ 'Root'! !

PRPierNode subclass: #PRStructureNode
	instanceVariableNames: 'holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRStructureNode class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aModel holder: aHolder
	^ (self on: aModel)
		holder: aHolder;
		yourself! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 1/21/2007 10:46'!
children
	^ self model enumerator collect: [ :each | self class on: each holder: self holder ]! !

!PRStructureNode methodsFor: 'actions' stamp: 'lr 5/28/2007 11:23'!
clickLink: aLink
	aLink isInternal
		ifTrue: [ (PRStructureNode on: aLink target holder: self holder) signalSelection ]
		ifFalse: [
			WebBrowser default
				ifNotNilDo: [ :browser | aLink url asUrl activate ] ]! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context
	^ self holder context structure: self model! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context: aContext
	self holder context: aContext! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
holder
	^ holder! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
holder: aHolder
	holder := aHolder! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model title! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 5/28/2007 11:13'!
text
	self model hasDocument
		ifFalse: [ ^ super text ].
	^ PRTextDocumentWriter new
		action: (MessageSend
			receiver: self
			selector: #clickLink:);
		write: self model document! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 4/25/2006 23:09'!
text: aString
	| editcontext |
	editcontext := self context command: model editCommandClass new.
	(editcontext isValid and: [ self context structure class respondsTo: #descriptionContents ])
		ifFalse: [ ^ super text: aString ].
	editcontext command
		write: aString using: self context structure class descriptionContents;
		execute.
	^ true! !

PRTextWriter subclass: #PRTextDocumentWriter
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
action
	^ action ifNil: [ action := self defaultAction ]! !

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
action: aBlock
	action := aBlock! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
anchorAttributesFor: anObject
	^ Array with: (TextColor color: Color darkGray)! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
defaultAction
	^ [ :value | value explore ]! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
defaultStream
	^ TextStream on: Text new! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
headerAttributesFor: anObject
	^ Array with: TextEmphasis bold! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
linkAttributesFor: anObject
	^ Array
		with: (PluggableTextAttribute
			evalBlock: [ self action value: anObject ])
		with: (anObject isBroken
			ifTrue: [ TextColor color: (Color r: 0.5 g: 0.0 b: 0.0) ]
			ifFalse: [ TextColor color: (Color r: 0.0 g: 0.0 b: 0.5) ])
		with: TextEmphasis underlined! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
listAttributesFor: anObject
	^ Array with: (TextIndent tabs: 1)! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
preformattedAttributeFor: anObject
	^ Array with: TextEmphasis italic! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitAnchor: anObject
	self
		withAttributes: (self anchorAttributesFor: anObject)
		do: [ super visitAnchor: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitHeader: anObject
	self
		withAttributes: (self headerAttributesFor: anObject)
		do: [ super visitHeader: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitLink: anObject
	self
		withAttributes: (self linkAttributesFor: anObject)
		do: [ super visitLink: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitOrderedList: anObject
	self
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitOrderedList: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitPreformatted: anObject
	self
		withAttributes: (self preformattedAttributeFor: anObject)
		do: [ super visitPreformatted: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitUnorderedList: anObject
	self
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitUnorderedList: anObject ]! !

!PRTextDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:30'!
withAttributes: aCollection do: aBlock
	^ self stream withAttributes: aCollection do: aBlock! !

OBBrowser subclass: #PRBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 5/28/2007 11:08'!
defaultMetaNode
	| root kernel structure description |
	root := OBMetaNode named: 'Root'.
	kernel := OBMetaNode named: 'Kernel'.
	structure := OBMetaNode named: 'Structure'.
	description := OBMetaNode named: 'Description'.
	root
		childAt: #children
			labeled: 'children'
			put: kernel.
	kernel
		childAt: #children
			labeled: 'instances'
			put: structure.
	structure
		childAt: #children
			labeled: 'children'
			put: structure;
		childAt: #description
			labeled: 'description'
			put: description;
		addFilter: OBModalFilter new.
	description
		childAt: #children
			labeled: 'children'
			put: description;
		childAt: #description
			labeled: 'description'
			put: description;
		addFilter: OBModalFilter new.
	^ root! !

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
defaultRootNode
	^ PRRootNode on: PRKernel instances! !

!PRBrowser class methodsFor: 'initializing' stamp: 'lr 3/9/2006 11:30'!
initialize
	self registerInWorldMenu! !

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 5/28/2007 11:10'!
optionalButtonPanel
	^ nil! !

!PRBrowser class methodsFor: 'initializing' stamp: 'lr 2/12/2007 19:07'!
registerInWorldMenu
	TheWorldMenu registerOpenCommand: { 'Pier Browser'. { self. #open } }! !

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
title
	^ 'Pier Browser'! !

!PRBrowser methodsFor: 'morphic' stamp: 'lr 3/9/2006 11:30'!
defaultBackgroundColor
	^ Color r: 0.151 g: 0.327 b: 0.720! !

MAElementMorph subclass: #PRStructureMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
buildMorphEditor
	^ (SimpleHierarchicalListMorph
		on: self
		list: #root
		selected: #selected
		changeSelected: #selected:
		menu: nil
		keystroke: nil)
			hResizing: #spaceFill;
			borderColor: #inset;
			borderWidth: 2;
			expandAll;
			yourself! !

!PRStructureMorph methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
root
	^ Array with: (PRStructureItemWrapper with: self model context root)! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
selected
	^ PRStructureItemWrapper with: self value! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
selected: aWrapper
	self value: (aWrapper ifNotNil: [ aWrapper item ]).
	self changed: #selected! !
PRBrowser initialize!
